import es
import playerlib
import gamethread
from configobj import ConfigObj
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "Dodgeball Script"
info.version = "1.0"
info.basename = "dodge_ball"
info.author = "chrismrulz"

config = ConfigObj(es.server_var['eventscripts_gamedir'] + '/cfg/dodgeball.ini')

oneplayereffects = int(config["Dodgeball"]["1v1effects"])
doexplosions = int(config["Dodgeball"]["doexplosions"])
allowradio = int(config["Dodgeball"]["allowradio"])
ball_model = config["Dodgeball"]["ball_model"]

def load():
	es.ServerVar('eventscripts_noisy').set(1)
	loadblock()

def es_map_start(event_var):
	es.ServerVar('phys_pushscale').set(650)
	setdownloads()
	es.precachemodel(ball_model)
	loadblock()

def loadblock():
	es.msg("#Green", "Dodgeball Script On - by Toph")

def unload():
	es.ServerVar('phys_pushscale').set(1)
	es.ServerVar('eventscripts_noisy').set(0)
	es.msg("#green", "Dodgeball Script Off")

def round_start(event_var):
	global oneplayermode
	oneplayermode = 0

def dofire(p1, p2, p3, p4 = "", p5 = ""):
	es.server.cmd('es_xfire %i %s %s [%s] [%s]' % (p1, p2, p3, p4, p5))

def oneplayercheck():
	if(oneplayereffects != 0 and es.getlivingplayercount(3) == 1 and es.getlivingplayercount(2) == 1 and oneplayermode == 0):
		global oneplayermode
		oneplayermode = 1
		if(oneplayereffects == 1):
			es.msg('#green', 'It is one versus one, the ball will be full of sparks.')
		elif(oneplayereffects == 2):
			es.msg('#green', 'It is one versus one, the ball will be on fire.')

def player_disconnect(event_var):
	oneplayercheck()

def player_death(event_var):
	oneplayercheck()

def player_hurt(event_var):
	userid = int(event_var['userid'])
	gamethread.delayed(0.1, es.remove, 'flashbang_projectile')
	if(doexplosions == 1):
		dofire(userid, '!self', 'DispatchEffect Explosion')
		es.emitsound('player', userid, 'weapons\hegrenade\explode4.wav', 1.0, 0.5)

def setdownloads():
	es.stringtable('downloadables', ball_model)
	es.stringtable('downloadables', 'models/forlix/soccer/soccerball.dx80.vtx')
	es.stringtable('downloadables', 'models/forlix/soccer/soccerball.dx90.vtx')
	es.stringtable('downloadables', 'models/forlix/soccer/soccerball.mdl')
	es.stringtable('downloadables', 'models/forlix/soccer/soccerball.phy')
	es.stringtable('downloadables', 'models/forlix/soccer/soccerball.sw.vtx')
	es.stringtable('downloadables', 'models/forlix/soccer/soccerball.vvd')
	es.stringtable('downloadables', 'models/forlix/soccer/soccerball.xbox.vtx')
	es.stringtable('downloadables', 'materials/models/forlix/soccer/soccerball.vmt')
	es.stringtable('downloadables', 'materials/models/forlix/soccer/soccerball.vtf')

def weapon_fire(event_var):
	userid = int(event_var['userid'])
	if(es.getplayerprop(userid, 'CBasePlayer.pl.deadflag') != 1):
		gamethread.delayed(0.1, setball)
		if(oneplayermode == 1):
			if(oneplayereffects == 1):
				sparks(userid)
			elif(oneplayereffects == 2):
				gamethread.delayed(0.1, dofire, (userid, 'flashbang_projectile', 'ignite'))
		gamethread.delayed(1.41, sendgive, userid)
		gamethread.delayed(1.42, es.remove, 'flashbang_projectile')

def checkammo(userid):
	player = playerlib.getPlayer(userid)
	if(player.getWeaponIndex('weapon_flashbang') == 0 or player.getAmmo('weapon_flashbang') == 0):
		return 0
	else:
		return 1

def sendgive(userid):
	dofire(userid, 'player_weaponstrip', 'kill')
	es.give(userid, 'player_weaponstrip')
	dofire(userid, 'player_weaponstrip', 'strip')
	gamethread.delayed(0.2, es.give, (userid, 'weapon_flashbang'))

def setball():
	bid = int(es.getentityindex('flashbang_projectile'))
	if(bid > 0):
		ball = es.precachemodel(ball_model)
		es.setindexprop(bid, 'CBaseEntity.m_nModelIndex', ball)
		es.setindexprop(bid, 'CBaseEntity.m_clrRender', -1)
	else:
		gamethread.delayed(0.1, setball)

def flashbang_detonate(event_var):
	userid = int(event_var['userid'])
	es.setplayerprop(userid, "CCSPlayer.m_flFlashMaxAlpha", 0)
	es.setplayerprop(userid, "CCSPlayer.m_flFlashDuration", 0)

def player_spawn(event_var):
	userid = int(event_var['userid'])
	es.setplayerprop(userid, "CBasePlayer.m_iHealth", 1)
	sendgive(userid)

def player_activate(event_var):
	if (int(es.server_var['allowradio']) != 1):
		es.server.cmd('es_cexec %s ignorerad' % event_var['userid'])

def sparks(userid):
	for i in range(1, 14):
		gamethread.delayed((i/10), dofire, (userid, 'flashbang_projectile', 'DispatchEffect ManhackSparks'))